/*
 * mcpasswd.c - used as interface to nnrpd for authentication of users
 *
 * Read this on stdin:
 *
 * N:ClientHost: hostname\r
 * N:ClientIP: IP-address\r
 * N:LocalIP: IP-address\r
 * N:LocalPort: port\r
 * N:ClientAuthname: username\r
 * N:ClientPassword: password\r
 * N:.\r
 *
 * Return:
 * 
 * User:username\r
 *
 * mc@hack.org
*/

#include <stdio.h>
#include <fcntl.h>
#include <string.h>
#include <unistd.h>
#include <sysexits.h>
#include <db.h>
#include <userdb.h>

#define SMBUF 128
#define NAMESTR "ClientAuthname: "
#define PASSSTR "ClientPassword: "

int
main(int argc, char *argv[])
{
    extern char *optarg;
    int opt;
    char s[1024];
    char uname[1024], pass[1024];
    char *fname;
    struct user user;

    if (argc < 2)
        exit(1);
    
    while ((opt = getopt(argc, argv, "f:")) != -1)
    {
        switch (opt)
        {
          case 'f':
            fname = optarg;
            break;
        }
    }

    /* Read from stdin */

    while (NULL != fgets(s, sizeof(s) - 1, stdin))
    {
        if (0 == strncmp(s, NAMESTR, strlen(NAMESTR)))
        {
            strcpy(uname, s + sizeof(NAMESTR) - 1);
            /* Shave off CRLF */
            if ('\n' == uname[strlen(uname) - 1])
            {
                uname[strlen(uname) - 1] = '\0';
            }
            if ('\r' == uname[strlen(uname) - 1])
            {   
                uname[strlen(uname) - 1] = '\0';
            }
        }
        if (0 == strncmp(s, PASSSTR, strlen(PASSSTR)))
        {
            strcpy(pass, s + sizeof(PASSSTR) - 1);
            if ('\n' == pass[strlen(pass) - 1])
            {
                pass[strlen(pass) - 1] = '\0';
                
            }
            if ('\r' == pass[strlen(pass) - 1])
            {   
                pass[strlen(pass) - 1] = '\0';
            }
        }
    }

    if (!uname[0] || !pass[0])
    {
        exit(3);
    }

    if (db_getuser(uname, &user))
    {
        if (0 == strcmp(user.password, pass))
        {
            printf("User:%s <%s>\n", user.fullname, user.address);
            exit(0);
        }
    }

    fprintf(stderr, "mcpasswd: user login failed.\n");
    exit(1);
}
