/* Here be constants, datatypes and function declerations for the
 * nnrpd user and ACL database. See nnrpd/userdb.c.
 *
 * mc@hack.org
 *
 */

/* Group flags */

#define GRP_SECRET 1
#define GRP_ACL    1 << 1

/* Membership flags */

#define MEM_READ     1
#define MEM_POST     1 << 1
#define MEM_APPROVE  1 << 2
#define MEM_EXTERNAL 1 << 3

/* GROUPMAX should be the number of elements in struct newsgroup. */

#define GROUPMAX 6
struct newsgroup
{
    char creator[128];
    char moderator[128];
    int expire;
    int flags;
    char title[182];
    char description[128];
};


/* USERMAX should be the number of elements in struct newsgroup. */

#define USERMAX 10
struct user
{
    char password[30];
    char fullname[64];
    char address[128];
    time_t online_since;
    time_t last_online;
    time_t total_time;
    long written_arts;
    long read_arts;
    char description[256];
    char faceurl[256];
};


/*
** Public functions
 */

int db_getgroup(char *group, struct newsgroup *newsgroup);
int db_getuser(char *username, struct user *user);
int db_getacl(char *group, char *user, int *acl);
int db_groupflag(char *group, int flag);
int db_aclflag(char *group, char *user, int flag);
